﻿<h1 id="dhcp-configuration">DHCP Configuration</h1>
<h3 id="in-this-how-to-we-will-cover-creating-a-dhcp-pool-on-cisco-ios-the-different-options-typically-configured-in-an-enterprise-dhcp-exclusions-and-dhcp-vrf-configuration-and-the-configuration-of-a-dhcp-relay">In this How To we will cover creating a DHCP pool on Cisco iOS, the different options typically configured in an enterprise, DHCP exclusions, and DHCP VRF configuration, and the configuration of a DHCP relay.</h3>
<p><img src="dhcp_network_diagram.png" alt="" /></p>
<ul>
<li><p>First we must configure the VLANs, assign the correct ports to the VLANs, and create the SVIs. It assumed that you already know how to do this. If not please refer to the <strong>VLANs</strong> How To's.</p>
</li>
<li><p>Next comes the actual DHCP iOS Configuration</p>
</li>
</ul>
<p><code>SW1(config)ip dhcp pool [NAME]</code> # This command will create the DHCP pool.</p>
<p><code>SW1(config-dhcp)#network [network address][CIDR]</code> # This command sets the network address in the pool</p>
<p><code>SW1(config-dhcp)#default-router [DG IP Address]</code> # This command sets the default gateway in the pool</p>
<p><code>SW1(config-dhcp)dns-server [Primary DNS IP][Secondary DNS IP]</code> # This command sets the DNS server IP addresses to be allocated in the pool</p>
<h3 id="this-is-the-basic-configuration-of-a-dhcp-pool-in-cisco-ios-to-get-the-pool-up-and-running-shown-below-is-the-full-configuration-for-both-dhcp-pools-in-our-diagram">This is the basic configuration of a DHCP pool in Cisco iOS to get the pool up and running. Shown below is the full configuration for both DHCP pools in our diagram</h3>
<p><img src="dhcp_basic_config.png" alt="" /></p>
<h3 id="--now-lets-go-over-configuring-the-lease-time-and-the-commonly-used-options-configured-in-a-dhcp-pool">- Now lets go over configuring the lease time and the commonly used <strong>&quot;options&quot;</strong> configured in a DHCP pool.</h3>
<p><code>SW1(config-dhcp)#lease 7</code> # This command sets a time for how long an IP address can assigned to an endpoint before being released back into the DHCP pool</p>
<p><code>SW1(config-dhcp)#option 150 ip [Primary CUCM IP] [Secondary CUCM IP]</code> # This command sets the IP addresses for the Cisco Unified Call Managers. These are the servers that deliver a phones configuration via TFTP.</p>
<p><code>SW1(config-dhcp)$option 66 ip [WDS|PXE IP address]</code> # This command sets the IP address for a Windows Deployment Server which is needed for  the Pre-execution Environment which allows re-imaging of computers over the LAN/Wire.</p>
<h3 id="--shown-below-is-the-full-configuration-of-these-options">- Shown below is the full configuration of these options.</h3>
<p><img src="dhcp_options_config.png" alt="" /></p>
<h3 id="--now-lets-go-over-exclusions-it-is-sometimes-needed-to-exclude-ip-addresses-from-the-dhcp-pool-to-be-assigned-in-this-example-we-will-exclude-the-printers-ip-address">- Now lets go over exclusions. It is sometimes needed to exclude IP addresses from the DHCP pool to be assigned. In this example we will exclude the printer's IP address.</h3>
<p><code>SW1(config)#ip dhcp excluded-address [IP Address | X.X.X.X]</code> # This command will exclude an IP address from being assigned to a user.</p>
<p><code>SW1(config)#ip dhcp excluded-address 10.10.10.50 10.10.10.60</code> # This command sets a range of IP addresses to be excluded from being assigned to an endpoint device.</p>
<h3 id="shown-below-is-the-full-configuration">Shown below is the full configuration.</h3>
<p><img src="dhcp_exclusion.png" alt="" /></p>
<h3 id="--now-we-are-going-to-go-over-vrf-support-for-dhcp-and-how-to-assign-a-dhcp-pool-to-a-vrfs-subnet-we-will-be-covering-vrfs-in-a-later-section">- Now we are going to go over VRF support for DHCP and how to assign a DHCP pool to a VRF's Subnet. We will be covering VRF's in a later section</h3>
<p><code>SW1(config)#ip dhcp pool [NAME]</code> # This command will create the DHCP pool.</p>
<p><code>SW1(config-dhcp)#vrf [NAME]</code> # This command will set the DHCP pool to be apart of the VRF</p>
<h3 id="the-full-configuration-is-shown-below">The full configuration is shown below.</h3>
<p><img src="vrf_dhcp.png" alt="" /></p>
<h1 id="now-we-will-cover-configuring-a-dhcp-relay-with-the-ip-helper-address-command-the-ip-helper-address-command-will-need-to-be-configured-under-each-interface-that-has-a-subnet-and-users-that-will-need-ip-addressing-from-the-dhcp-server">Now we will cover configuring a DHCP relay with the IP Helper-address command. The ip helper-address command will need to be configured under each interface that has a subnet and users that will need IP addressing from the DHCP server.</h1>
<p><img src="dhcp_relay_network_diagram.png" alt="" /></p>
<h3 id="now-lets-go-over-the-actual-configuration">Now lets go over the actual configuration</h3>
<p><code>SW1(config)#interface vlan 10</code> # This command creates an SVI on the switch</p>
<p><code>SW1(config-if)#ip helper-address [ip address X.X.X.X]</code> # This command will now redirect any broadcast traffic destined to the ip address that we have configured</p>
<h3 id="shown-below-is-the-full-configuration-1">Shown below is the full configuration</h3>
<p><img src="dhcp_relay_config.png" alt="" /></p>
<h1 id="verification">Verification</h1>
<h3 id="now-we-will-go-over-the-show-commands-used-to-troubleshoot-and-help-manage-dhcp-pools-on-cisco-ios">Now we will go over the show commands used to troubleshoot and help manage DHCP pools on Cisco iOS</h3>
<p><code>SW1#show ip dhcp pool</code> # This command will show the current DHCP pools configured on your Cisco iOS device, the amount of available IP addresses in the pool, and the currently leased addresses.</p>
<p><img src="show_ip_dhcp_pool.png" alt="" /></p>
<p><code>SW1#show ip dhcp binding</code> # This command will show all the current IP addresses assigned to devices, the MAC addresses of devices, and the lease times.</p>
<p><img src="show_ip_dhcp_binding.png" alt="" /></p>
<p><code>SW1#show ip dhcp vrf [name] binding *</code> # This command will show all the DHCP bindings under a VRF</p>
<p><code>SW1#show ip dhcp conflicts</code> # This command will show if any devices are trying to pull the same IP address from a DHCP pool</p>
<p><code>SW1#clear ip dhcp binding [ * | X.X.X.X | vrf]</code> # This command will clear DHCP bindings. There are a few options you put on this command. Clear all bindings with an *. Clear one binding by specifying an IP address. And clear bindings under a VRF.</p>
<p><code>SW1#clear ip dhcp conflicts [ * | X.X.X.X | vrf]</code> # This command will clear DHCP conflicts. There are a few options you put on this command. Clear all conflicts with an *. Clear one conflict by specifying an IP address. And clear conflicts under a VRF.</p>
<h3 id="in-the-photo-shown-below-we-can-see-a-wiresharktcp-capture-of-the-dora-process-from-endpoint-to-cisco-ios-device">In the photo shown below we can see a Wireshark/TCP capture of the DORA process from endpoint to Cisco iOS device.</h3>
<p><img src="wireshark_capture.png" alt="" /></p>
<h3 id="in-this-capture-you-intitially-see-the-discover-is-sent-with-a-source-address-of-0000-because-the-device-does-not-have-an-ip-address-then-after-the-dhcpack-we-see-the-device-now-has-an-ip-address-in-the-videos-accompinying-these-how-tos-we-will-take-a-deep-dive-into-each-dhcp-packet-in-dora">In this capture you intitially see the discover is sent with a source address of 0.0.0.0 because the device does not have an IP address. Then after the DHCPack we see the device now has an IP address. In the video's accompinying these How To's we will take a deep dive into each DHCP packet in DORA.</h3>
